<!doctype html>
<html>
<head>
    <meta charset='utf-8'>
    <title>好文本网站内容管理系统GTCMS自动安装</title>
    <style type="text/css">
        table{max-width:100%;background-color:transparent;border-collapse:collapse;border-spacing:0;}.table{width:100%;margin-bottom:20px;}.table th,.table td{padding:8px;line-height:20px;text-align:left;vertical-align:middle;border-top:1px solid #dddddd;}.table-bordered{border:1px solid #dddddd;border-collapse:separate;*border-collapse:collapse;border-left:0;-webkit-border-radius:4px;-moz-border-radius:4px;border-radius:4px;}.table-bordered th,.table-bordered td{border-left:1px solid #dddddd;}.table-bordered caption+thead tr:first-child th,.table-bordered caption+tbody tr:first-child th,.table-bordered caption+tbody tr:first-child td,.table-bordered colgroup+thead tr:first-child th,.table-bordered colgroup+tbody tr:first-child th,.table-bordered colgroup+tbody tr:first-child td,.table-bordered thead:first-child tr:first-child th,.table-bordered tbody:first-child tr:first-child th,.table-bordered tbody:first-child tr:first-child td{border-top:0;}.table-bordered thead:first-child tr:first-child>th:first-child,.table-bordered tbody:first-child tr:first-child>td:first-child,.table-bordered tbody:first-child,tr:first-child>th:first-child{-webkit-border-top-left-radius:4px;-moz-border-radius-topleft:4px;border-top-left-radius:4px;}.table-bordered thead:first-child tr:first-child>th:last-child,.table-bordered tbody:first-child tr:first-child>td:last-child,.table-bordered tbody:first-child tr:first-child>th:last-child{-webkit-border-top-right-radius:4px;-moz-border-radius-topright:4px;border-top-right-radius:4px;}.table-bordered thead:last-child tr:last-child>th:first-child,.table-bordered tbody:last-child tr:last-child>td:first-child,.table-bordered tbody:last-child tr:last-child>th:first-child,.table-bordered tfoot:last-child tr:last-child>td:first-child,.table-bordered tfoot:last-child tr:last-child>th:first-child{-webkit-border-bottom-left-radius:4px;-moz-border-radius-bottomleft:4px;border-bottom-left-radius:4px;}input{width:200px;background-color:#fff;border:1px solid #ccc;-webkit-box-shadow:inset 0 1px 1px rgba(0,0,0,0.075);-moz-box-shadow:inset 0 1px 1px rgba(0,0,0,0.075);box-shadow:inset 0 1px 1px rgba(0,0,0,0.075);-webkit-transition:border linear .2s,box-shadow linear .2s;-moz-transition:border linear .2s,box-shadow linear .2s;-o-transition:border linear .2s,box-shadow linear .2s;transition:border linear .2s,box-shadow linear .2s;}select,textarea,input[type="text"],input[type="password"]{display:inline-block;height:20px;padding:4px 6px;margin:1px 0;font-size:14px;line-height:20px;color:#555;vertical-align:middle;-webkit-border-radius:4px;-moz-border-radius:4px;border-radius:4px;}select{width:70px;background-color:#fff;border:1px solid #ccc;height:30px;}.btn{display:inline-block;*display:inline;*zoom:1;padding:4px 12px;margin-bottom:0;font-size:14px;line-height:20px;text-align:center;vertical-align:middle;cursor:pointer;text-shadow:0 1px 1px rgba(255,255,255,0.75);border-radius:4px;*margin-left:.3em;-webkit-box-shadow:inset 0 1px 0 rgba(255,255,255,.2),0 1px 2px rgba(0,0,0,.05);-moz-box-shadow:inset 0 1px 0 rgba(255,255,255,.2),0 1px 2px rgba(0,0,0,.05);box-shadow:inset 0 1px 0 rgba(255,255,255,.2),0 1px 2px rgba(0,0,0,.05);}.btn-success{color:#ffffff;text-shadow:0 -1px 0 rgba(0,0,0,0.25);background-color:#5bb75b;background-image:-moz-linear-gradient(top,#62c462,#51a351);background-image:-webkit-gradient(linear,0 0,0 100%,from(#62c462),to(#51a351));background-image:-webkit-linear-gradient(top,#62c462,#51a351);background-image:-o-linear-gradient(top,#62c462,#51a351);background-image:linear-gradient(to bottom,#62c462,#51a351);background-repeat:repeat-x;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff62c462',endColorstr='#ff51a351',GradientType=0);border-color:#51a351 #51a351 #387038;border-color:rgba(0,0,0,0.1) rgba(0,0,0,0.1) rgba(0,0,0,0.25);*background-color:#51a351;filter:progid:DXImageTransform.Microsoft.gradient(enabled = false);}
        span.fred {color:red;}
    </style>
</head>
<body>    <?php
class DBManager
{
    var $dbHost = '';
    var $dbUser = '';
    var $dbPassword = '';
    var $dbSchema = '';
    
    function __construct($host,$user,$password,$schema)
    {
        $this->dbHost = $host;
        $this->dbUser = $user;
        $this->dbPassword = $password;
        $this->dbSchema = $schema;
    }
    
    function createFromFile($sqlPath,$delimiter = '(;\n)|((;\r\n))|(;\r)',$prefix = '',$commenter = array('#','--'))
    {
        //判断文件是否存在
        if(!file_exists($sqlPath))
            return false;
        
        $handle = fopen($sqlPath,'rb');    
        
        $sqlStr = fread($handle,filesize($sqlPath));
        
        //通过sql语法的语句分割符进行分割
        $segment = explode(";",trim($sqlStr)); 
        
        //var_dump($segment);
        
        //去掉注释和多余的空行
        foreach($segment as & $statement)
        {
            $sentence = explode("\n",$statement);
            
            $newStatement = array();
            
            foreach($sentence as $subSentence)
            {
                if('' != trim($subSentence))
                {
                    //判断是会否是注释
                    $isComment = false;
                    foreach($commenter as $comer)
                    {
                        if(preg_match("/^(".$comer.")/",trim($subSentence)))
                        {
                            $isComment = true;
                            break;
                        }
                    }
                    //如果不是注释，则认为是sql语句
                    if(!$isComment)
                        $newStatement[] = $subSentence;                    
                }
            }
            
            $statement = $newStatement;
        }
        //对表名加前缀
        if('' != $prefix)
        {
            
        
            //只有表名在第一行出现时才有效 例如 CREATE TABLE talbeName
    
            $regxTable = "^[\`\'\"]{0,1}[\_a-zA-Z]+[\_a-zA-Z0-9]*[\`\'\"]{0,1}$";//处理表名的正则表达式
            $regxLeftWall = "^[\`\'\"]{1}";
            
            $sqlFlagTree = array(
                    "CREATE" => array(
                            "TABLE" => array(
                                    "$regxTable" => 0
                                )
                        ),
                    "INSERT" => array(
                            "INTO" => array(
                                "$regxTable" => 0
                            )
                        )
                    
                    );
                            
            foreach($segment as & $statement)
            {
                $tokens = split(" ",$statement[0]);
                
                $tableName = array();
                $this->findTableName($sqlFlagTree,$tokens,0,$tableName);
                
                if(empty($tableName['leftWall']))
                {
                    $newTableName = $prefix.$tableName['name'];
                }
                else{
                    $newTableName = $tableName['leftWall'].$prefix.substr($tableName['name'],1);
                }
                
                $statement[0] = str_replace($tableName['name'],$newTableName,$statement[0]);
            }
            
        }        
        //组合sql语句
        foreach($segment as & $statement)
        {
            $newStmt = '';
            foreach($statement as $sentence)
            {
                $newStmt = $newStmt.trim($sentence)."\n";
            }
                
            $statement = $newStmt;
        }
          self::saveByQuery($segment);
        
        return true;
    }
    
    private function saveByQuery($sqlArray)
    {
        $conn = mysql_connect($this->dbHost,$this->dbUser,$this->dbPassword);
        
        mysql_select_db($this->dbSchema);
        
        foreach($sqlArray as $sql)
        {
   mysql_query("set names utf8"); //声明字符集
            mysql_query($sql);
        }        
        mysql_close($conn);
    }
    
    private function findTableName($sqlFlagTree,$tokens,$tokensKey=0,& $tableName = array())
    {
        $regxLeftWall = "^[\`\'\"]{1}";
        
        if(count($tokens)<=$tokensKey)
            return false;        
        
        if('' == trim($tokens[$tokensKey]))
        {
            return self::findTableName($sqlFlagTree,$tokens,$tokensKey+1,$tableName);
        }
        else
        {
            foreach($sqlFlagTree as $flag => $v)
            {    
                if(eregi($flag,$tokens[$tokensKey]))
                {
                    if(0==$v)
                    {
                        $tableName['name'] = $tokens[$tokensKey];
            
                        if(eregi($regxLeftWall,$tableName['name']))
                        {
                            $tableName['leftWall'] = $tableName['name']{0};
                        }
                        
                        return true;
                    }
                    else{
                        return self::findTableName($v,$tokens,$tokensKey+1,& $tableName);
                    }
                }
            }
        }
        
        return false;
    }
}
function writeArrayToFile($fileName,$dataArray,$delimiter="\r\n")
{
    $handle=fopen($fileName, "wb");
    
    $text = '';
    
    foreach($dataArray as $data)
    {
        $text = $text.$data.$delimiter;
    }
    fwrite($handle,$text);
}

if(isset($_POST['gamyserver'])) {
 

    //创建文件 $fileName 文件名 $value 内容
    function installFile($fileName, $value)
    {
        if(!file_exists($fileName)) {
            is_dir(dirname($fileName)) || installdir(dirname($fileName));
            file_put_contents($fileName, $value) || die('创建文件'.$fileName.'失败.');            
        }
    }
    
    /**
     * 创建目录
     *
     * @param string $dirs 要创建的目录名 支持传入数组
     */
    function installdir($dirs)
    {
        if(is_array($dirs)) {
            foreach ($dirs as $dir){
                if(!file_exists($dir)) {
                    mkdir($dir, 0700, true) || die('创建目录'.$dir.'失败');
                }
            }
        } else {
            if(!file_exists($dirs)) {
                mkdir($dirs, 0700, true) || die('创建目录'.$dirs.'失败');
            }
        } 
    }

    if(empty($_POST['gamyserver'])){ 
        echo "数据库IP为空";
        echo " <a href='install.php'>返回</a>";
        exit ();
    };
    if(empty($_POST['gamydatabase'])){ 
        echo "数据库名为空";
        echo " <a href='install.php'>返回</a>";
        exit ();
    };
    if(empty($_POST['gamyuser'])){ 
        echo "数据库用户名为空";
        echo " <a href='install.php'>返回</a>";
        exit ();
    };
    if(empty($_POST['gamypassword'])){ 
        echo "数据库密码为空";
        echo " <a href='install.php'>返回</a>";
        exit ();
    };
    if(empty($_POST['gamyport'])){ 
        echo "数据库端口号为空";
        echo " <a href='install.php'>返回</a>";
        exit ();
    };
$configStr1=<<<st
<?php
defined('GTPHP_PATH') || exit('Access Denied');
// 系统基本配置 **********************************************
\$Config['UrlControllerName'] = 'c';         // 自定义控制器名称 例如: index.php?c=index
\$Config['UrlActionName'] = 'a';             // 自定义方法名称 例如: index.php?c=index&a=IndexAction      
\$Config['Gdebug'] = 'false';         // 报告错误 true为报告错误
\$Config['Adminuser'] = 'admin';         // 超级管理员

// 插件设置
\$Plugins_upimgurl =  '/Static/uploads/';            // 编辑器插件上传路径

class myconfig {
    public function myconfig()
    {
        \$myconfig=array(
        'Tohtml' =>  'false',    // 生成静态文件 true开启，false关闭.
        'Suffix' => '.htm', // 伪静态后缀
        'DRurl' => 1, // 伪静态URL 1关闭 2开启
        'Uploads' => 'Static/',
        'APagesize' => '10',    // 每页文章数
        'PPagesize' => '8',    // 每页图片数
        'VPagesize' => '4',    // 每页视频数
        'DPagesize' => '6',    // 每页下载数
        'Sitesatrt' => '2014-12'        // 建站日期
        );
        return \$myconfig;
    }
    public function mydbconfig()
    {
        \$dbconfig=array(
        // required
        'database_type' => 'mysql', \n
st;
$configStr2=<<<st
        );
        return \$dbconfig;
    }
    //前端插件
    public function myplugin()
    {
        \$plugins=array(
            'plugin_1'=> array(
            'plugin_on_off'=>'true', //插件开/关
            'plugin_name'=>'插件名称', //插件名称
            'plugin_directory'=>'TestHook' //插件安装目录
            ),
            'plugin_2'=> array(
            'plugin_on_off'=>'true', //插件开/关
            'plugin_name'=>'插件名称', //插件名称
            'plugin_directory'=>'TestHook1' //插件安装目录
            )
        );
        return \$plugins;
    }
}
st;
$installconfig="";
$installconfig.="'server' =>";
$installconfig.="'".$_POST['gamyserver']."', //数据库所在IP，如果是本地，默认localhost \n";
$installconfig.="'database_name' =>";
$installconfig.="'".$_POST['gamydatabase']."', //数据库名 \n";
$installconfig.="'username' =>";
$installconfig.="'".$_POST['gamyuser']."', //数据库用户名 \n";
$installconfig.="'password' =>";
$installconfig.="'".$_POST['gamypassword']."', //数据库密码 \n";
$installconfig.="'port' =>";
$installconfig.="".$_POST['gamyport'].", //数据库端口号 \n";
$installconfig.="'charset' =>";
$installconfig.="'utf8' //字符集 \n";
$configStr=$configStr1.$installconfig.$configStr2;

$ConfigFile='Gsys/Config.php';
installFile($ConfigFile, $configStr);//创建正式配置文件
//分别是主机，用户名，密码，数据库名，数据库编码
$dbM = new DBManager($_POST['gamyserver'].':'.$_POST['gamyport'],$_POST['gamyuser'],$_POST['gamypassword'],$_POST['gamydatabase']);
$db = $dbM->createFromFile('gtcms.sql',null,'');

if($db){
echo '安装成功!<br>';
echo '超级管理员帐号:admin 密码:goodtext.org';
echo "<br>登陆后请及时修改密码. <a href='index.php?c=login&a=index'>进入后台管理登陆界面</a>";
} else {
echo '数据导入失败!';
exit ();
}

$file = "install.php";  
if(file_exists($file)){  
    @unlink ($file);  
}  
}else{
?>
<form method="post" name="install">
    <table class="table table-bordered" style=" width:700px; margin:50px auto;">
        <tr>
            <td colspan="2" style="text-align:center"><h2>安装</h2></td>
        </tr>
        <tr>
            <td width="332">操作系统</td>
            <td><?php echo PHP_OS; ?></td>
        </tr>
        <tr>
            <td>PHP 版本</td>
            <td><?php echo PHP_VERSION; ?></td>
        </tr>
        <tr>
            <td>附件上传大小</td>
            <td><?php echo @ini_get('file_uploads') ? ini_get('upload_max_filesize') : 0; ?></td>
        </tr>
        <tr>
            <td>GD 库</td>
            <td><?php $gd_info = gd_info();
 echo $gd_info['GD Version'];
unset($gd_info); ?>
            </td>
        </tr>
        <tr>
            <td colspan="2" style="text-align:center;">
                检查读写权限
            </td>
        </tr><?php 
// 目录、文件读写权限检查
$check_dirs = array(
        'Static/Uploads',
        'Gsys'
        );
 ?> <?php
                foreach($check_dirs as $v):
                $path = ''.$v;
                ?>
                <tr>
                    <td> <?php echo './'.$v; ?> </td>
                    <?php
                    if(file_exists($path) && is_writable($path)) {
                        echo '<td> 可写 </td>';
                    } else {
                        echo '<td> 不可写 </td>';
                    }
                    ?>
                </tr>
                <?php endforeach; ?>
        <tr>
            <td colspan="2" style="text-align:center;">
                数据库连接配置
            </td>
        </tr>
        <tr>
            <td>服务器名</td>
            <td><input type="text" name="gamyserver" value="localhost"></td>
        </tr>
        <tr>
            <td>数据库名</td>
            <td><input type="text" name="gamydatabase" value=""></td>
        </tr>
        <tr>
            <td>数据库用户名</td>
            <td><input type="text" name="gamyuser" value=""></td>
        </tr>
        <tr>
            <td>数据库密码</td>
            <td><input type="text" name="gamypassword" value=""></td>
        </tr>
        <tr>
            <td>数据库端口号</td>
            <td><input type="text" name="gamyport" value="3306"></td>
        </tr>
        <tr>
            <td colspan="2" style="text-align:center;">
                <input type="submit" value="开始安装" class="btn btn-success"/>
            </td>
        </tr>
    </table>
</form>

</body>
</html>

<?php
}

?>